# LambertW
### Lambert W function and associated omega constant

Linux, OSX: [![Build Status](https://travis-ci.org/jlapeyre/LambertW.jl.svg)](https://travis-ci.org/jlapeyre/LambertW.jl)
&nbsp;
Windows: [![Build Status](https://ci.appveyor.com/api/projects/status/github/jlapeyre/LambertW.jl?branch=master&svg=true)](https://ci.appveyor.com/project/jlapeyre/lambertw-jl)
&nbsp; &nbsp; &nbsp;
[![Coverage Status](https://coveralls.io/repos/github/jlapeyre/LambertW.jl/badge.svg?branch=master)](https://coveralls.io/github/jlapeyre/LambertW.jl?branch=master)
[![codecov.io](http://codecov.io/github/jlapeyre/LambertW.jl/coverage.svg?branch=master)](http://codecov.io/github/jlapeyre/LambertW.jl?branch=master)

<!-- [![LambertW](http://pkg.julialang.org/badges/LambertW_0.6.svg)](http://pkg.julialang.org/?pkg=LambertW&ver=0.6) -->


### lambertw

The [Lambert W function](http://en.wikipedia.org/wiki/Lambert_W_function),
also called the omega function or product logarithm.

```julia
lambertw(z,k)   # Lambert W function for argument z and branch index k
lambertw(z)     # the same as lambertw(z,0)
```

`z` may be Complex or Real. `k` must be an integer. For Real
`z`, `k` must be either `0` or `-1`.

Examples:

```julia
julia> lambertw(10)
1.7455280027406994

julia> lambertw(e)
1

julia> lambertw(1.0)
0.5671432904097838

julia> lambertw(-pi/2 + 0im)  / pi
4.6681174759251105e-18 + 0.5im
```

### lambertwbp(x,k=0)

Return `1 + W(-1/e + z)`, for `z` satisfying `0 <= abs(z) < 1/e`,
on the branch of index `k`, where `k` must be either `0` or `-1`. This
function is designed to minimize loss of precision near the branch point `z=-1/e`.
`lambertwbp(z,k)` converges to `Float64` precision for `abs(z) < 0.32`.

If `k=-1` and `imag(z) < 0`, the value on the branch `k=1` is returned.

```julia
julia> lambertwbp(1e-3,-1)
-0.07560894118662498

julia> lambertwbp(0)
-0.0
```

`lambertwbp` uses a series expansion about the branch point `z=-1/e`.
The loss of precision in `lambertw` is analogous to the loss of precision
in computing the `sqrt(1-x)` for `x` close to `1`.

### LambertW.finv(lambertw)

The functional inverse of the Lambert W function.
```
julia> finv(lambertw)(lambertw(1.0))
1.0

julia> finv(lambertw)(lambertw(1+im/2,3))
1.0 + 0.49999999999999944im
```

### omega constant

The [omega constant](http://en.wikipedia.org/wiki/Omega_constant)

```julia
julia> ω
ω = 0.5671432904097...

julia> omega
ω = 0.5671432904097...

julia> ω * exp(ω)
1.0

julia> big(ω)
5.67143290409783872999968662210355549753815787186512508135131079223045793086683e-01 with 256 bits of precision

julia> lambertw(1) == float(ω)
true
```
<!-- ### Notes -->

<!-- Both `lambertw` and `lambertwbp` throw `DomainErrors` rather than return `NaN`s. -->
<!-- This behavior is reversed by setting `LAMBERTW_USE_NAN=true` at the top of -->
<!-- the source file `lambertw.jl`. -->
 
<!--  LocalWords:  lambertw jacobisymbol julia ulia im eval LambertW
 -->
<!--  LocalWords:  lambertwbp lambertwm NaN bitstype Combinatorics
 -->
<!--  LocalWords:  BigInt imag sqrt
 -->

"""
    module LambertW

This module computes the Lambert W function,
or product log function,
and related quantities.

Functions: `lambertw`, `lambertwbp`, `finv`

Constants: `omega`, `lambertwbranchpoint`
"""
module LambertW

export lambertw, lambertwbp

const omega_const_bf_ = Ref{BigFloat}()

function __init__()
    # allocate storage for this BigFloat constant each time this module is loaded
    omega_const_bf_[] =
        parse(BigFloat, "0.5671432904097838729999686622103555497538157871865125081351310792230457930866845666932194")
end

Base.@irrational lambertwbranchpoint -0.367879441171442321595 -big(1)/exp(big(1))

@doc """
        lambertbranchpoint::Irrational

The branchpoint of the branches `k = 0` and `k = -1`, `-1/e`.

# Example
```julia-repl
julia> import LambertW.lambertwbranchpoint

julia> lambertw(lambertwbranchpoint, 0)
-1.0

julia> lambertw(lambertwbranchpoint, -1)
-1.0
```
""" lambertwbranchpoint

#@doc "hi" lambertbranchpoint

### Lambert W function

"""
    lambertw(z::Complex{T}, k::V=0) where {T<:Real, V<:Integer}
    lambertw(z::T, k::V=0) where {T<:Real, V<:Integer}

Compute the `k`th branch of the Lambert W function of `z`. If `z` is real, `k` must be
either `0` or `-1`. For `Real` `z`, the domain of the branch `k = -1` is `[-1/e, 0]` and the
domain of the branch `k = 0` is `[-1/e, Inf]`. For `Complex` `z`, and all `k`, the domain is
the complex plane.

```jldoctest
julia> lambertw(-1/e, -1)
-1.0

julia> lambertw(-1/e, 0)
-1.0

julia> lambertw(0, 0)
0.0

julia> lambertw(0, -1)
-Inf

julia> lambertw(Complex(-10.0, 3.0), 4)
-0.9274337508660128 + 26.37693445371142im
```
"""
lambertw(z, k::Integer=0, maxits::Integer=1000) = _lambertw(float(z), k, maxits)

# lambertw(e + 0im, k) is ok for all k
# Maybe this should return a float. But, this should cause no type instability in any case
function _lambertw(::typeof(MathConstants.e), k, maxits)
    k == 0 && return 1
    throw(DomainError(k))
end
_lambertw(x::Irrational, k, maxits) = _lambertw(float(x), k, maxits)
function _lambertw(x::Union{Integer, Rational}, k, maxits)
    if k == 0
        x == 0 && return float(zero(x))
        x == 1 && return convert(typeof(float(x)), LambertW.omega) # must be a more efficient way
    end
    return _lambertw(float(x), k, maxits)
end

### Real z

function _lambertw(x::Real, k, maxits)
    k == 0 && return lambertw_branch_zero(x, maxits)
    k == -1 && return lambertw_branch_one(x, maxits)
    throw(DomainError(k, "lambertw: real x must have branch k == 0 or k == -1"))
end

# Real x, k = 0
# This appears to be inferrable with T=Float64 and T=BigFloat, including if x=Inf.
# There is a magic number here. It could be noted, or possibly removed.
# In particular, the fancy initial condition selection does not seem to help speed.
function lambertw_branch_zero(x::T, maxits)::T where T<:Real
    isnan(x) && return(NaN)
    x == Inf && return Inf # appears to return convert(BigFloat, Inf) for x == BigFloat(Inf)
    one_t = one(T)
    oneoe = -one_t / convert(T, MathConstants.e)  # The branch point
    x == oneoe && return -one_t
    oneoe <= x || throw(DomainError(x))
    itwo_t = 1 / convert(T, 2)
    if x > one_t
        lx = log(x)
        llx = log(lx)
        x0 = lx - llx - log1p( - llx / lx) * itwo_t
    else
        x0 = (567//1000) * x
    end
    return lambertw_root_finding(x, x0, maxits)
end

# Real x, k = -1
function lambertw_branch_one(x::T, maxits) where T<:Real
    oneoe = -one(T) / convert(T, MathConstants.e)
    x == oneoe && return -one(T) # W approaches -1 as x -> -1/e from above
    oneoe <= x || throw(DomainError(x))  # branch domain exludes x < -1/e
    x == zero(T) && return -convert(T, Inf) # W decreases w/o bound as x -> 0 from below
    x < zero(T) || throw(DomainError(x))
    return lambertw_root_finding(x, log(-x), maxits)
end

### Complex z

_lambertw(z::Complex{<:Integer}, k, maxits) = _lambertw(float(z), k, maxits)
# choose initial value inside correct branch for root finding
function _lambertw(z::Complex{T}, k, maxits) where T<:Real
    one_t = one(T)
    local w::Complex{T}
    pointseven = 7//10
    if abs(z) <= one_t/convert(T, MathConstants.e)
        if z == 0
            k == 0 && return z
            return complex(-convert(T, Inf), zero(T))
        end
        if k == 0
            w = z
        elseif k == -1 && imag(z) == 0 && real(z) < 0
            w = complex(log(-real(z)), 1//10^7) # need offset for z ≈ -1/e.
        else
            w = log(z)
            k != 0 ? w += complex(0, k * 2 * pi) : nothing
        end
    elseif k == 0 && imag(z) <= pointseven && abs(z) <= pointseven
        w = abs(z+ 1//2) < 1//10 ? imag(z) > 0 ? complex(pointseven, pointseven) : complex(pointseven, -pointseven) : z
    else
        if real(z) == convert(T, Inf)
            k == 0 && return z
            return z + complex(0, 2*k*pi)
        end
        real(z) == -convert(T, Inf) && return -z + complex(0, (2*k+1)*pi)
        w = log(z)
        k != 0 ? w += complex(0, 2*k*pi) : nothing
    end
    return lambertw_root_finding(z, w, maxits)
end

### root finding, iterative solution

# Use Halley's root-finding method to find
# x = lambertw(z) with initial point x0.
function lambertw_root_finding(z::T, x0::T, maxits) where T <: Number
    two_t = convert(T, 2)
    x = x0
    lastx = x
    lastdiff = zero(T)
    converged::Bool = false
    for i in 1:maxits
        ex = exp(x)
        xexz = x * ex - z
        x1 = x + 1
        x -= xexz / (ex * x1 - (x + two_t) * xexz / (two_t * x1 ))
        xdiff = abs(lastx - x)
        if xdiff <= 3 * eps(abs(lastx)) || lastdiff == xdiff  # second condition catches two-value cycle
            converged = true
            break
        end
        lastx = x
        lastdiff = xdiff
    end
    converged || @warn("lambertw with z=", z, " did not converge in ", maxits, " iterations.")
    return x
end

### Inverse of Lambert W function

"""
    finv(::typeof(lambertw)) -> Function

The functional inverse of the Lambert W function.

# Example
```julia-repl
julia> import LambertW.finv

julia> finv(lambertw)(lambertw(1))
1.0
```
"""
finv(::typeof(lambertw)) = W -> W * exp(W)

### omega constant

const _omega_const = 0.567143290409783872999968662210355

# The BigFloat `omega_const_bf_` is set via a literal in the function __init__ to prevent a segfault

# compute omega constant via root finding
# We could compute higher precision. This converges very quickly.
function omega_const(::Type{BigFloat})
    precision(BigFloat) <= 256 && return omega_const_bf_[]
    myeps = eps(BigFloat)
    oc = omega_const_bf_[]
    for i in 1:100
        nextoc = (1 + oc) / (1 + exp(oc))
        abs(oc - nextoc) <= myeps && break
        oc = nextoc
    end
    return oc
end

"""
    omega
    ω

The constant defined by `ω exp(ω) = 1`.

# Example
```jldoctest
julia> ω
ω = 0.5671432904097...

julia> omega
ω = 0.5671432904097...

julia> ω * exp(ω)
1.0

julia> big(omega)
5.67143290409783872999968662210355549753815787186512508135131079223045793086683e-01
```
"""
const ω = Irrational{:ω}()
@doc (@doc ω) omega = ω

Base.Float64(::Irrational{:ω}) = _omega_const
Base.Float32(::Irrational{:ω}) = Float32(_omega_const)
Base.Float16(::Irrational{:ω}) = Float16(_omega_const)
Base.BigFloat(::Irrational{:ω}) = omega_const(BigFloat)

### Expansion about branch point x = -1/e

# Refer to the paper "On the Lambert W function". In (4.22)
# coefficients μ₀ through μ₃ are given explicitly. Recursion relations
# (4.23) and (4.24) for all μ are also given. This code implements the
# recursion relations.

# (4.23) and (4.24) give zero based coefficients.
cset(a, i, v) = a[i+1] = v
cget(a, i) = a[i+1]

# (4.24)
function compute_a_coeffs(k, m, a)
    sum0 = zero(eltype(m))
    for j in 2:(k - 1)
        sum0 += cget(m, j) * cget(m, k + 1 - j)
    end
    cset(a, k, sum0)
    return sum0
end

# (4.23)
function compute_m_coefficients(k, m, a)
    kt = convert(eltype(m), k)
    mk = (kt - 1) / (kt + 1) *(cget(m, k - 2) / 2 + cget(a, k - 2) / 4) -
        cget(a, k) / 2 - cget(m, k - 1) / (kt + 1)
    cset(m, k, mk)
    return mk
end

# We plug the known value μ₂ == -1//3 for (4.22) into (4.23) and
# solve for α₂. We get α₂ = 0.
# Compute array of coefficients μ in (4.22).
# m[1] is μ₀
function compute_branch_point_coeffs(T::DataType, n::Int)
    a =  Array{T}(undef, n)
    m =  Array{T}(undef, n)
    cset(a, 0, 2)  # α₀ literal in paper
    cset(a, 1, -1) # α₁ literal in paper
    cset(a, 2, 0)  # α₂ get this by solving (4.23) for alpha_2 with values printed in paper
    cset(m, 0, -1) # μ₀ literal in paper
    cset(m, 1, 1)  # μ₁ literal in paper
    cset(m, 2, -1//3) # μ₂ literal in paper, but only in (4.22)
    for i in 3:(n - 1)  # coeffs are zero indexed
        compute_a_coeffs(i, m, a)
        compute_m_coefficients(i, m, a)
    end
    return m
end

const BRANCH_POINT_COEFFS_FLOAT64 = compute_branch_point_coeffs(Float64, 500)

# Base.Math.@horner requires literal coefficients
# It cannot be used here because we have an array of computed coefficients
function horner(x, coeffs::AbstractArray, n)
    n += 1
    ex = coeffs[n]
    for i = (n - 1):-1:2
        ex = :(muladd(t, $ex, $(coeffs[i])))
    end
    ex = :( t * $ex)
    return Expr(:block, :(t = $x), ex)
end

# write functions that evaluate the branch point series
# with `num_terms` number of terms.
for (func_name, num_terms) in (
    (:wser3, 3), (:wser5, 5), (:wser7, 7), (:wser12, 12),
    (:wser19, 19), (:wser26, 26), (:wser32, 32),
    (:wser50, 50), (:wser100, 100), (:wser290, 290))
    iex = horner(:x, BRANCH_POINT_COEFFS_FLOAT64, num_terms)
    @eval function ($func_name)(x) $iex end
end

# Converges to Float64 precision
# We could get finer tuning by separating k=0, -1 branches.
# Why is wser5 omitted ?
# p is the argument to the series which is computed
# from x before calling `branch_point_series`.
function branch_point_series(p, x)
    x < 4e-11 && return wser3(p)
    x < 1e-5 && return wser7(p)
    x < 1e-3 && return wser12(p)
    x < 1e-2 && return wser19(p)
    x < 3e-2 && return wser26(p)
    x < 5e-2 && return wser32(p)
    x < 1e-1 && return wser50(p)
    x < 1.9e-1 && return wser100(p)
    x > 1 / MathConstants.e && throw(DomainError(x))  # radius of convergence
    return wser290(p)  # good for x approx .32
end

# These may need tuning.
function branch_point_series(p::Complex{T}, z) where T<:Real
    x = abs(z)
    x < 4e-11 && return wser3(p)
    x < 1e-5 && return wser7(p)
    x < 1e-3 && return wser12(p)
    x < 1e-2 && return wser19(p)
    x < 3e-2 && return wser26(p)
    x < 5e-2 && return wser32(p)
    x < 1e-1 && return wser50(p)
    x < 1.9e-1 && return wser100(p)
    x > 1 / MathConstants.e && throw(DomainError(x))  # radius of convergence
    return wser290(p)
end

function _lambertw0(x) # 1 + W(-1/e + x)  , k = 0
    ps = 2 * MathConstants.e * x
    series_arg = sqrt(ps)
    branch_point_series(series_arg, x)
end

function _lambertwm1(x) # 1 + W(-1/e + x)  , k = -1
    ps = 2 * MathConstants.e * x
    series_arg = -sqrt(ps)
    branch_point_series(series_arg, x)
end

"""
    lambertwbp(z, k=0)

Compute accurate value of `1 + W(-1/e + z)`, for `abs(z)` in `[0, 1/e]` for `k` either `0` or `-1`.
This function is faster and more accurate near the branch point `-1/e` between `k=0` and `k=1`.
The result is accurate to Float64 precision for abs(z) < 0.32.
If `k=-1` and `imag(z) < 0`, the value on the branch `k=1` is returned.

# Example
```jldoctest
julia> lambertw(-1/e + 1e-18, -1)
-1.0

julia> lambertwbp(1e-18, -1)
-2.331643983409312e-9

# Same result, but 1000 times slower
julia> convert(Float64, (lambertw(-BigFloat(1)/e + BigFloat(10)^(-18), -1) + 1))
-2.331643983409312e-9
```

!!! note
    `lambertwbp` uses a series expansion about the branch point `z=-1/e` to avoid loss of precision.
    The loss of precision in `lambertw` is analogous to the loss of precision
    in computing the `sqrt(1-x)` for `x` close to `1`.
"""
function lambertwbp(x::Number, k::Integer)
    k == 0 && return _lambertw0(x)
    k == -1 && return _lambertwm1(x)
    throw(ArgumentError("expansion about branch point only implemented for k = 0 and -1."))
end
lambertwbp(x::Number) = _lambertw0(x)

end #module

## integer arguments return floating point types
@test lambertw(0) isa AbstractFloat
@test lambertw(0) == 0

### math constant, MathConstants.e e

# could return math const e, but this would break type stability
@test lambertw(1) isa AbstractFloat
@test lambertw(MathConstants.e, 0) == 1


## convert irrationals to float

@test isapprox(lambertw(pi), 1.0736581947961492)
@test isapprox(lambertw(pi, 0), 1.0736581947961492)

## default branch is  k = 0
@test lambertw(1.0) == lambertw(1.0, 0)

## BigInt args return BigFloats
@test typeof(lambertw(BigInt(0))) == BigFloat
@test typeof(lambertw(BigInt(3))) == BigFloat

## Any Integer type allowed for second argument
@test lambertw(-0.2, -1) == lambertw(-0.2, BigInt(-1))

## BigInt for second arg does not promote the type
@test typeof(lambertw(-0.2, -1)) == typeof(lambertw(-0.2, BigInt(-1)))

for (z, k, res) in [ (0, 0 , 0), (complex(0, 0), 0 , 0),
                   (complex(0.0, 0), 0 , 0), (complex(1.0, 0), 0, 0.567143290409783873) ]
    if Int != Int32
        @test isapprox(lambertw(z, k), res)
        @test isapprox(lambertw(z), res)
    else
        @test isapprox(lambertw(z, k), res; rtol = 1e-14)
        @test isapprox(lambertw(z), res; rtol = 1e-14)
    end
end

for (z, k) in ((complex(1, 1), 2), (complex(1, 1), 0), (complex(.6, .6), 0),
              (complex(.6, -.6), 0))
    let w
        @test (w = lambertw(z, k) ; true)
        @test abs(w*exp(w) - z) < 1e-15
    end
end

@test abs(lambertw(complex(-3.0, -4.0), 0) - Complex(1.075073066569255, -1.3251023817343588)) < 1e-14
@test abs(lambertw(complex(-3.0, -4.0), 1) - Complex(0.5887666813694675, 2.7118802109452247)) < 1e-14
@test (lambertw(complex(.3, .3), 0); true)

# bug fix
# The routine will start at -1/e + eps * im, rather than -1/e + 0im,
# otherwise root finding will fail
if Int != Int32
    @test isapprox(abs(lambertw(-1.0/MathConstants.e  + 0im, -1)), 1; atol=1e-15)
else
    @test abs(lambertw(-1.0/MathConstants.e  + 0im, -1) + 1) < 1e-7
end
# lambertw for BigFloat is more precise than Float64. Note
# that 70 digits in test is about 35 digits in W
let W
    for z in [ BigFloat(1), BigFloat(2), complex(BigFloat(1), BigFloat(1))]
        @test (W = lambertw(z); true)
        @test abs(z - W * exp(W)) < BigFloat(1)^(-70)
    end
end

###  ω constant

## get ω from recursion and compare to value from lambertw
let sp = precision(BigFloat)
    setprecision(512)
    @test lambertw(big(1)) == big(LambertW.omega)
    setprecision(sp)
end

@test lambertw(1) == float(LambertW.omega)
@test convert(Float16, LambertW.omega) == convert(Float16, 0.5674)
@test convert(Float32, LambertW.omega) == 0.56714326f0
@test lambertw(BigInt(1)) == big(LambertW.omega)

using DeepConvert
# lambertw loses precision near -1/e
# These are diagnostics.
# One thing that at least helps convergence near the pole
# is to add a very small imaginary part.  1e-100 * im or so.

function converr(z,k)
    w = lambertw(z,k)
   convert(Float64,abs(w*exp(w)-z))
end

converr(z) = converr(z,0)

mbig{T<:Real}(x::T) = BigFloat(x)
mbig(z::Complex) = complex(BigFloat(real(z)),BigFloat(imag(z)))

# compare lambertw to bigfloat version
function bigcomp(z,k)
    zr = eval(parse(z))
    zb = deepbigfloat(z)
    wb = lambertw(zb,k)
    w = lambertw(zr,k)
    -log10(convert(Float64,abs(wb-w)))
end


bigcomp(z) = bigcomp(z,0)

# compare lambertw to series expansion about pole
function sercomp(x::String)
    xr = eval(parse(x))
    xb = deepbigfloat(x) - 1/big(e)
    w = lambertw(xb,-1)
    ws = lambertwm1(xr)
    -log10(convert(Float64,abs(ws-w)))
end

# compare sercomp("1/10^7") to bigcomp("-1/e + 1/10^7",-1)
# They are roughly the same. So this is the crossover point:
# x = 1/10^7
# for smaller x, the series lambertwm1 is better for k=-1.

export lamwcoeff, cmpbp, cmpfp, xlambertw, bigbp
export cmpxlam,cmpexp

# Testing and development for expansion about branch point.  Refer to
# the paper "On the Lambert W function".  In (4.22) coefficients μ₀
# through μ₃ are given explicitly. Recursion relations (4.23) and
# (4.24) for all μ are also given. This code implements the recursion
# relations.

# (4.23) and (4.24) give zero based coefficients
cset(a,i,v) = a[i+1] = v
cget(a,i) = a[i+1]

# (4.24)
function compa(k,m,a)
    sum0 = zero(eltype(m))
    for j in 2:k-1
        sum0 += cget(m,j) * cget(m,k+1-j)
    end
    cset(a,k,sum0)
    sum0
end

# (4.23)
function compm(k,m,a)
    kt = convert(eltype(m),k)
    mk = (kt-1)/(kt+1) *(cget(m,k-2)/2 + cget(a,k-2)/4) -
        cget(a,k)/2 - cget(m,k-1)/(kt+1)
    cset(m,k,mk)
    mk
end

# We plug the known value μ₂ == -1//3 for (4.22) into (4.23) and
# solve for α₂. We get α₂ = 0.
# compute array of coefficients μ in (4.22).
# m[1] is μ₀
function lamwcoeff(T::DataType, n::Int)
    a = Array(T,n)
    m = Array(T,n)
    cset(a,0,2)  # α₀ literal in paper
    cset(a,1,-1) # α₁ literal in paper
    cset(a,2,0)  # α₂ get this by solving (4.23) for alpha_2 with values printed in paper
    cset(m,0,-1) # μ₀ literal in paper
    cset(m,1,1)  # μ₁ literal in paper
    cset(m,2,-1//3) # μ₂ literal in paper, but only in (4.22)
#    compa(3,m,a)  # α₃, from (4.24) get 1/9,   who knows if correct
#    compm(3,m,a)  # μ₃, from (4.23) get 11 / 72  agrees with explicit number in paper
#                  and this relies on the value α₃
    for i in 3:n-1  # coeffs are zero indexed
        compa(i,m,a)
        compm(i,m,a)
    end
    return m
end

const LAMWMU_FLOAT64 = lamwcoeff(Float64,100)
const LAMWMU_BIGRAT = lamwcoeff(Rational{BigInt},20)
const LAMWMU_BIGFLOAT = lamwcoeff(BigFloat,100)
const LAMWMU_RAT = lamwcoeff(Rational{Int},10)

function wser{T<:AbstractArray}(p,a::T,n::Int)
    sum0 = zero(p)
    for i in 2:n
        sum0 += p^(i-1) * a[i]
    end
    sum0
end


function _lambertw0(x::Float64,n) # 1 + W(-1/e + x)  , k = 0
    ps = 2*convert(typeof(x),e)*x;
    p = sqrt(ps)
    wser(p,LAMWMU_FLOAT64,n)
end

function _lambertwm1(x::Float64,n) # 1 + W(-1/e + x)  , k = -1
    ps = 2*convert(typeof(x),e)*x;
    p = -sqrt(ps)
    wser(p,LAMWMU_FLOAT64,n)
end

function _lambertw0(x::BigFloat,n) # 1 + W(-1/e + x)  , k = 0
    ps = 2*e*x;
    p = sqrt(ps)
    wser(p,LAMWMU_BIGFLOAT,n)
end

function _lambertwm1(x::BigFloat,n) # 1 + W(-1/e + x)  , k = -1
    ps = 2*e*x;
    p = -sqrt(ps)
    wser(p,LAMWMU_BIGFLOAT,n)
end

function alambertwbp{T<:Real}(x::T,k::Int,n::Int)
    k == 0 && return _lambertw0(x,n)
    k == -1 && return _lambertwm1(x,n)
    error("exansion about branch point only implemented for k = 0 and -1")
end

# do a big float root finding computation equivalent to alambertwbp
function bigbp(x,k)
    one(x) + lambertw(-one(x)/convert(typeof(x),e) + x, k)
end

# compare error from BigFloat exact (root finding) and expansion about branch point
# x = distance from branch point
# k = branch index, either 0 or -1
# n = order of expansion (n-1 terms because we omit the constant -1 )
# The result is that n > 5 no longer changes the result in the best case.
# Note that radius of convergence is reported to be sqrt(2), we are well within this.
# So, it makes sense to include these terms, but no more:
#    μ₄ = -113//1080
#    μ₅ =  697//17280
#
#    For smaller x, fewer coefficients are needed.
function cmpbp(x,k,n)
    w1 = alambertwbp(x,k,n)
    w2 = bigbp(x,k)
    float64(w1-w2)
end

xlambertw(x,k) = one(x) + lambertw(-one(x)/e + 1/x,k)

# The following three functions are good for comparing accuracy
# of expansion vs root finding near the bp.
# This confirms that the crossover is still about about 1/x = 10^7
cmpxlam(x,k) = (a=xlambertw(BigInt(x),k); (xlambertw(x,k) - a)/a)
cmpexp(x,k) = (a=xlambertw(BigInt(x),k); (alambertwbp(1/float(x),k) -a)/a)
cmpexp(x,k,n) = (a=xlambertw(BigInt(x),k); (alambertwbp(1/float(x),k,n) -a)/a)

function cmpfp(x,k)
    w1 = lambertw(-1/e + x,k)
    w2 = lambertw(-1/big(e)+x,k)
    float64(w1-w2)
end

using LambertW
using LambertW: lambertwbranchpoint
using Test

@testset "exceptions" begin
    ### domain errors

    @test_throws DomainError lambertw(-2.0, 0)
    @test_throws DomainError lambertw(-2.0, -1)
    @test_throws DomainError lambertw(-2.0, 1)
    @test isnan(lambertw(NaN))

    ## math constant e
    @test_throws DomainError lambertw(MathConstants.e, 1)
    @test_throws DomainError lambertw(MathConstants.e, -1)

    ###  expansion about branch point

    # not a domain error, but not implemented
    @test_throws ArgumentError lambertwbp(1, 1)
    @test_throws DomainError lambertw(.3, 2)
end

@testset "LambertW.jl" begin
  include("lambertw_test.jl")
end

@testset "branch point" begin
    # Expansions about branch point converges almost to machine precision
    # except near the radius of convergence.
    # Complex args are not tested here.

    if Int != Int32
        # Test double-precision expansion near branch point using BigFloats
        sp = precision(BigFloat)
        z = BigFloat(1)/10^12
        setprecision(2048)
        for i in 1:300
#            innerarg = z - 1 / big(MathConstants.e)
            innerarg = z + lambertwbranchpoint
            # branch k = 0
            wo = lambertwbp(Float64(z))
            xdiff = abs(-1 + wo - lambertw(innerarg))
            if xdiff > 5e-16
                @warn(Float64(z), " ", Float64(xdiff))
            end
            @test xdiff < 5e-16

            #  branch k = -1
            wo = lambertwbp(Float64(z), -1)
            xdiff = abs(-1 + wo - lambertw(innerarg, -1))
            if xdiff > 5e-16
                @warn(Float64(z), " ", Float64(xdiff))
            end
            @test xdiff < 5e-16
            z  *= 1.1
            if z > 0.23 break end
        end
        setprecision(sp)

        # test the expansion about branch point for k=-1,
        # by comparing to exact BigFloat calculation.
        @test lambertwbp(1e-20, -1) - 1 - lambertw(-BigFloat(1)/big(MathConstants.e)+ BigFloat(1)/BigFloat(10)^BigFloat(20), -1) < 1e-16
        @test abs(lambertwbp(Complex(.01, .01), -1) - Complex(-0.2755038208041206, -0.1277888928494641)) < 1e-14

    else  # if Int != Int32
        @info "Skipping branch point tests"
    end
end

@testset "infinities" begin
    ### infinite args or return values
    @test lambertw(0, -1) == lambertw(0.0, -1) == -Inf
    @test lambertw(Inf, 0) == Inf
    @test lambertw(complex(Inf, 1), 0) == complex(Inf, 1)
    @test lambertw(complex(Inf, 0), 1) == complex(Inf, 2pi)
    @test lambertw(complex(-Inf, 0), 1) == complex(Inf, 3pi)
    @test lambertw(complex(0.0, 0.0), -1) == complex(-Inf, 0.0)
end

## value at branch point where real branches meet
@testset "at branch point" begin
    k0val = lambertw(lambertwbranchpoint, 0)
    km1val = lambertw(lambertwbranchpoint, -1)
    @test k0val == -1.0
    @test km1val == -1.0
    @test k0val isa Float64
    @test km1val isa Float64
end

using LambertW

mu1 = 1
mu2 = -1//3
mu3 = 1//8 * (-2*mu2 + mu1^2 -4 * mu2^2)
mu4 = 1//10 * (-2*mu3 + 3 * mu1 * mu2 -10 * mu2 * mu3)
mu5 = 1//12 * (-2*mu4 + 2 * (2*mu1*mu3+mu2^2) - 6 * (mu3^2 + 2*mu2*mu4))

function muterm(n,a)
    T = eltype(a)
    sum1 = zero(T)
    for j in 1:n-1
        sum1 += a[j] * a[n-j]
#        println("sum1 $sum1")
    end
    sum1 *= n/convert(T,2)
#    println("  * sum1 $sum1")
    sum2 = zero(T)
    for j in 2:n
        sum2 += a[j] * a[n+2-j]
#        println("sum2 $sum2")
    end
    sum2 *= -(n+2)
#    println("  * sum2 $sum2")
    a[n+1] = (-2*a[n] + sum1 + sum2)/(2*(n+2))
end

function genmu(T::DataType, n::Int)
    a = Array(T,n)
    a[1] =  one(T)
    a[2] = -one(T) / convert(T,3)
#    a[3] = convert(T,11) / convert(T,72)
    for k in 2:n-1
        muterm(k,a)
    end
    a
end

mu64a = genmu(Float64,6)
mu64b = genmu(Rational,6)
mu64c = genmu(BigFloat,100)

# lambertwbf with many terms
function newlam(x)
    a = mu64a
    s = zero(x)
    y = sqrt(2*e*x)
#    y = 1.0
    for i in 1:length(a)
#        println("mu $(a[i])")
        s += y^i * a[i]
    end
    s
end

function hornerlam(x)
    a = mu64a
    y = sqrt(2*e*x)
    s = zero(x)
    for i in (length(a)):-1:1
        s = a[i] + s * y
    end
    return s * y
end


# Test shows backward is more precise than forwards.
function rnewlam(x)
    s = zero(x)
    y = sqrt(2*e*x)
    for i in length(mu64a):-1:1
        s += y^i * mu64a[i]
    end
    s
end

function bnewlam(x)
    s = zero(x)
    y = sqrt(2*e*x)
    for i in 1:length(mu64c)
        s += y^i * mu64c[i]
    end
    s
end


function lamnew(y)
    x = sqrt(2*e*y)
    mu1*x + mu2*x^2 + mu3*x^3 + mu4*x^4 +mu5*x^5
end

lamwex(x) = 1+lambertw(-1/big(e)+BigFloat(1)/x)

lamwex64(x) = 1+lambertw(-1/e + 1/x)

diffx(x) = float64((w=lamwex(x); (lambertwbp(float64(1/x)) - w)/w))
diffxn(x) = float64((w=lamwex(x); (lamnew(float64(1/x)) - w)/w))

diffrat(x) = abs(diffxn(x)/diffx(x))

diffx64(x) = (w=lamwex(x); float64((w-lamwex64(x))/w))

diffrat64n(x) = abs(diffxn(x)/diffx64(x))
diffrat64(x) = abs(diffx(x)/diffx64(x))

# 1. Compute the "exact" value of lambertw/
# 2. Compute series values with coeffs from paper, and our coeffs.
# 3. Compute error in each series value.
# 4. Print ratio of errors.
# Small number means new coeffs are doing better.
# column 2 is x = z + 1/e.
# column 3 is the value for the variable in series expansion: sqrt(2*e*x)
# column 4 is ratio of error in new series to errr in old series
# column 5 is ratio of error in old series to exact val Float64 error
# column 6 is ratio of error in new series to exact val Float64 error
# Crossover point for using series with Float64 is where column 5 is about unity
# This is about x = 1e-5
# Results show increasing improvement until higher order terms are not
# significant.
# We use inverses here and there to avoid losing BigFloat precision
function diffratpr()
    println("y        x        p         en/eo     eo/eex    en/eex")
    iex = 0
    pref = 2
    for i in 1:30
        if iseven(i)
            pref = 7
        else
            iex += 1
            pref = 1
        end
        y = pref*10^iex
        x = 1/y
        @printf( "%.1e  %.1e  %.2e  %.2e  %.2e  %.2e\n" ,
                float(y), x , sqrt(2*e*x),  diffrat(y), diffrat64(y),diffrat64n(y))
    end
end

#

# for several months, at least, emacs regularly insersts whitespace at the end of lines

find . -type f -name "*.jl README* REQU* .travis.yml LICENSE* " -exec sh -c 'for i;do sed 's/[[:space:]]*$//' "$i">/tmp/.$$ && cat /tmp/.$$ > "$i";done' arg0 {} +
